<template>
    <div>
        <base-header class="header pb-8 pt-5 pt-lg-8 d-flex align-items-center">
            <b-breadcrumb :items="items"></b-breadcrumb>    
            <!-- Mask -->
        </base-header>
        <div class="container-fluid mt--7">
            <div class="row">
                <div class="col">
                    <div class="card shadow">
                        <div class="card-header border-0">
                        <div class="row align-items-center">
                            <div class="col">
                            <h3 class="mb-0">
                                {{title}}
                            </h3>
                            <select name="list-app" v-model="listHotel" class="custom-select d-block w-100" @change="getHotelID()">
                                <option v-for="hotel in hotelData" :key="hotel.hotel_id" :value="hotel.hotel_id">{{hotel.hotel_name}}</option>
                            </select>
                            <span class="text-danger" v-if="error !== ''">{{error}}</span>
                            </div>
                            <div class="col text-right">
                                <button class="btn btn-lg btn-primary" @click="showCreate = true">Create Buiding</button>
                            </div>
                            <div>
                                <modal :show="showCreate" @close="showCreate = false">
                                    <template slot="header">
                                        <h5 class="modal-title">Create</h5>
                                    </template>
                                    <div>
                                        <div class="col-lg-12">
                                            <base-input alternative=""
                                                        label="Buiding name"
                                                        placeholder="Buiding name"
                                                        input-classes="form-control-alternative"
                                                        v-model="buiding_name"
                                            />
                                            <span class="text-danger" v-if="error !== ''">{{error}}</span>
                                        </div>
                                    </div>
                                    <template slot="footer">
                                            <base-button type="secondary" @click="showCreate = false">Close</base-button>
                                            <base-button type="primary" @click="checkData">Create</base-button>
                                    </template>
                                </modal>
                            </div>
                        </div>
                        </div>

                        <div class="table-responsive">
                        <table class="table align-items-center table-flush text-center">
                            <tr>
                                <th>No.</th>
                                <th>Buiding name</th>
                                <th>Manage</th>
                            </tr>

                            <tr v-for="(buiding,index) in buidingData" :key="index" :class="{editing: buiding == dataEdit}" v-cloak>
                            <td>{{index+1}}</td>
                            <td class="budget">
                                <div class="view">
                                <span>{{buiding.buiding}}</span>
                                <small @click="goFloor(buiding.buiding)"><router-link class="text-blue" to="#"> setting floor</router-link></small>
                                </div>
                                <div class="edit">
                                <base-input alternative=""
                                                    placeholder="App name"
                                                    input-classes="form-control-alternative"
                                                    v-model="buiding.buiding"
                                />
                                </div>
                            </td>
                            <td>
                                <div class="view">
                                    <span @click="editData(buiding)"><router-link class="text-primary" to="#"><i class="fas fa-pen"></i> Edit</router-link></span> |  
                                    <span @click="del(buiding)"><router-link class="text-danger" to="#"><i class="far fa-trash-alt"></i> Delete</router-link></span>
                                </div>
                                <div class="edit">
                                    <span @click="saveEdit(buiding)"><router-link class="text-success" to="#"><i class="fas fa-save"></i> Save</router-link></span> |  
                                    <span @click="cancelEdit()"><router-link class="text-default" to="#"><i class="far fa-window-close"></i> Cancel</router-link></span>
                                </div>
                            </td>

                            </tr>

                        </table>
                        </div>
                    </div>
                </div>
            </div>
    </div>
</div>
</template>
<script>

  export default {
    name: 'buiding-name',
    data() {
      return {
        title: 'Buiding name',
        hotelData : [],
        buidingData : [],
        message : '',
        error :'',
        buiding_name : '',
        showCreate : false,
        dataEdit : null,
        listHotel : '',
        items: [
          {
            text: 'Company',
            to: '/topic'
          },
          {
            text: 'App',
            to: '/app'
          },
          {
            text: 'Hotel',
            to: '/hotel'
          },
          {
            text: 'Buiding',
            active: true
          }
        ]
      }
    },
    created() {
        this.getDataHotel()
        this.getDataBuiding()
    },
    methods: {
        getDataHotel(){
            this.error = ''
            this.$http.get('/manage/hotel/'+localStorage.user_id+'/'+ localStorage.app_id)
            .then(response => {
                if(!response.data.message){
                    this.hotelData = response.data
                    this.listHotel = localStorage.hotel_id
                }else{
                    this.message = response.data.message
                }
          })
        },
        getDataBuiding(){
            this.error = ''
            this.$http.get('/manage/buiding/'+localStorage.user_id+'/'+ localStorage.app_id+'/'+localStorage.hotel_id)
            .then(response => {
                if(!response.data.message){
                    this.buidingData = response.data
                }else{
                    this.message = response.data.message
                    this.buidingData = []
                }
          })
        },
        checkData(){
            if(this.buiding_name === ''){
                this.error = 'Please enter buiding name'
            }else{
                this.sendCreate()
            }
        },
        sendCreate(){
            this.$http.post('/manage/buiding/create',{
                user_id : localStorage.user_id,
                app_id : localStorage.app_id,
                hotel_id : localStorage.hotel_id,
                buiding : this.buiding_name
            })
          .then(response => {
              if(response.data.message === 'success'){
                this.$swal({
                    title: "Created!",
                    icon: "success",
                    timer: 3000
                })
                this.getDataBuiding()
                this.showCreate = false
                this.buiding_name = ''
                this.error = ''
              }else if(response.data.message === 'cant_create'){
                  this.error = 'Can not use this buiding name !!'
              }
          })
          .catch(() => this.checkCreateBuiding())
        },
        checkCreateBuiding(){
            this.error = 'Create failed!!'
        },
        editData(buiding){
            localStorage.buiding = buiding.buiding
            this.dataEdit = buiding
        },
        cancelEdit(){
            this.dataEdit = null
            this.getDataBuiding()
        },
        saveEdit(buiding){
            this.$swal({
                    title: "Confirm edit buiding name?",
                    icon: "warning",
                    buttons: ['cancel','confirm']
                })
                .then((confirm) => {
                    if (confirm) {
                            this.$http.post('/manage/buiding/edit',{
                            user_id : localStorage.user_id,
                            hotel_id : localStorage.hotel_id,
                            app_id : localStorage.app_id,
                            buiding_old : localStorage.buiding,
                            buiding : buiding.buiding
                        })
                        .then(response => {
                            if(response.data.message === 'cant_edit'){
                                this.checkEditBuiding()
                            }else if(response.data.message === 'success'){
                                this.$swal({
                                title: "Edited!",
                                icon: "success",
                                timer: 3000
                                })
                                this.getDataBuiding()
                            }
                        })
                        .catch(() => this.checkEditBuiding())
                    }
                })
        },
        del(buiding){
                this.$swal({
                    title: "Confirm delete buiding name!!",
                    icon: "warning",
                    buttons: ['cancel','confirm'],
                    dangerMode: true
                }).then((confirm) => {
                    if (confirm) {
                            this.$http.post('/manage/buiding/del',{
                            user_id : localStorage.user_id,
                            hotel_id : localStorage.hotel_id,
                            app_id : localStorage.app_id,
                            buiding : buiding.buiding
                        })
                        .then(response => {
                            if(response.data.message === 'success'){
                                this.$swal({
                                title: "Deleted!",
                                icon: "success",
                                timer: 3000
                                })
                            }
                            this.getDataBuiding()
                        })
                        .catch(() => this.error = 'Delete failed!!' )
                    }
                })
        },
        checkEditBuiding(){
            this.error = 'Edit failed!!'
        },
        getHotelID(){
            localStorage.hotel_id = this.listHotel
            this.getDataBuiding()
        },
        goFloor(buiding){
            localStorage.buiding = buiding
            this.$router.push('/floor')
        }
    },
  };
</script>
<style scoped>
[v-cloak] {
      display: none;
    }
    .edit {
      display: none;
    }
    .editing .edit {
      display: block
    }
    .editing .view {
      display: none;
    }
</style>